<template lang="pug">
b-card( title="Чаты" )
	b-fields
		b-field.is-flex-grow-1( label="Фильтр по имени/юзернейму" :on-border='true' )
			b-input( v-model='username' )
		b-field( label="Фильтр по названию группы" :on-border='true' )
			b-input( v-model='groupName' )
		b-field
			.button.is-danger.is-light( @click='clear' ) Очистить фильтр
	b-table(
		v-if='clients && clients.length'
		:columns='columns'
		:data='clients'
		:loading='pending')
		template( #messages='{ item }' )
			.is-flex.is-align-items-center.is-justify-content-flex-start( :class='{ "has-text-success": !!item.messages }' )
				span.icon
					i.fa-solid.fa-envelope
				p.ml-1( v-if='item.messages' ) {{ item.messages }}
		template( #groups='{ item }' )
			b-tags
				template( v-for='(group, i) in item.groups' )
					b-tag(
						v-if='group'
						as="router-link"
						type="primary"
						is-light
						has-delete
						@on-delete='removeClientFromGroup(group.id, item.id)'
						:to='{ name: "Group", params: { id: group.id } }') {{ group.name }}
				.dropdown.is-hoverable( v-if='groups(item.groups) && groups(item.groups).length' )
					.dropdown-trigger
						.button.is-success.is-light.is-small
							span.icon.is-small
								i.fa-solid.fa-plus
					.dropdown-menu
						.dropdown-content
							a.dropdown-item(
								v-for='(group, i) in groups(item.groups)' :key='i'
								@click='addClientToGroup(group.id, item.id)' ) {{ group.name }}
		template( #buttons='{ item }' )
			.buttons
				router-link.button.is-link.is-small( :to='{ name: "Chat", params: { tg_id: item.tg_id } }' )
					span.icon.is-small
						i.fa-solid.fa-arrow-right
		template( #empty ) 
			template( v-if='username || groupName' ) По заданным параметрам пользователи не найдены &#128532;
			template( v-else ) Пока что никто не пользовался ботом
	b-pagination( v-model='page' :total='lastPage' )
</template>

<script setup>
import BTags from "@/components/tag/Tags.vue"
import BTag from "@/components/tag/Tag.vue"
import BFields from "@/components/form/Fields.vue"
import BField from "@/components/form/Field.vue"
import BInput from "@/components/form/Input.vue"
import BTable from "@/components/table/Table.vue"
import BPagination from "@/components/table/Pagination.vue"

import { ref, computed, onMounted, watch } from "vue"
import { useRoute } from "vue-router"
import { useClientSrore } from "@/stores/client"
import { useGroupStore } from "@/stores/group"
import { useSocket } from "@/stores/socket"

const columns = [
	{
		field: "messages"
	},
	{
		label: "ID",
		field: "id"
	},
	{
		label: "Имя",
		field: "fullName"
	},
	{
		label: "Username",
		field: "username"
	},
	{
		label: "Группы",
		field: "groups"
	},
	{
		field: "buttons"
	}
]

const $route = useRoute()
const cs = useClientSrore()
const gs = useGroupStore()
const io = useSocket()

const pending = ref(false)

const clients = computed(() => cs.clients)

const groups = computed(() => gs.notExistGroups)

const page = computed({
	get: () => cs.page,
	set: val => cs.page = val
})
const lastPage = computed(() => cs.last_page)

const username = computed({
	get: () => cs.filter,
	set: val => cs.filter = val
})
const groupName = computed({
	get: () => cs.groupName,
	set: val => cs.groupName = val
})

const clear = () => {
	username.value = ""
	groupName.value = ""
}

const fetch = async () => {
	pending.value = true
	gs.page = 1
	gs.limit = 10000
	await cs.getClients()
	await gs.getGroups()
	pending.value = false
}

watch(username, () => {
	cs.filter_type = [ "username", "fullName" ]
	page.value = 1
	fetch()
})

watch(groupName, () => {
	page.value = 1
	fetch()
})

watch(page, fetch)
watch($route, () => page.value = 1)

const removeClientFromGroup = async (groupId, clientId) => {
	pending.value = true
	await cs.editClientGroup(groupId, clientId, "remove")
	await fetch()
}
const addClientToGroup = async (groupId, clientId) => {
	pending.value = true
	await cs.editClientGroup(groupId, clientId, "add")
	await fetch()
}

onMounted(() => {
	cs.filter_type = null
	cs.filter = null
	cs.limit = 20
	fetch()

	io.on(`new_message`, cs.getClients)
})
</script>

<style lang="scss" scoped>
.table-wrapper:deep(td.groups) {
	width: 20rem;
	max-width: 20rem;
}

.fields:deep(.field) {
	&:last-of-type {
		flex: 0;
	}
}
</style>